DEFDBL A-Z
'ct: number of components including sources
'ls: highest node number
'lv: number of voltage sources
't(p) n1(p) n2(p): component type and nodes where it is connected
'v(p) g(p): value and phase
CLS : ON ERROR GOTO TcapError
PRINT "*******************************************************************************"
PRINT "* Based on: 'TSC Electrical Circuit Analysis Program V3.3.6m jul/2/86         * "
PRINT "* By Dr. Allen Katz, chairman, dept electronics engineering technology        *"
PRINT "* Trenton State College, CN550, Trenton, NJ 8625                              *"
PRINT "* The author reserves rights to this program; however, copying and use for    *"
PRINT "* educational purposes is encouraged. Report any errors or problems with this *"
PRINT "* program to the author (609)771 2487'    **QBasic 11/jul/04 by LW1ECP**      *"
PRINT "*******************************************************************************"
PRINT "All units in V, A, ohm, F, H, Hz. Please enter '47pF' as '47E-12'."
PRINT "Node voltages and impedances are referenced to node 0 (ground)."
PRINT "All calculations assumed at DC (0 freq) unless frequency set with 'f' option."
'if error goto Menu
PRINT : PRINT "Want additional information (y/n)? ";
b$ = LCASE$(INPUT$(1)): PRINT b$: IF b$ <> "y" GOTO NoMoreInfo
CLS : PRINT "Tcap analyses circuits consisting of resistors, capacitors,"
PRINT "inductors and several common active devices."
PRINT "1- Draw the circuit to be analayzed on a sheet of paper."
PRINT "2- Assign a number to each element. This is the component number."
PRINT "3- Assign a number to each network node. A node is present at the"
PRINT "   connection between elements. No two elements may be connected without"
PRINT "   a node between them. Every element must begin and end at a node."
PRINT "   Any number of elements may be connected to a common node."
PRINT "4- Once all the elements and nodes are numbered, you are ready to enter"
PRINT "   your network into tcap.": PRINT
PRINT "Tcap will first ask whether you wish to read a file."
PRINT "You can save ('s') on disk circuit files you have previously worked on."
PRINT "If you do not have a previous file you wish to work on, type 'n' "
PRINT "and tcap will put you in the new file mode."
PRINT "In the 'new file' mode, tcap will first ask for the highest node number."
PRINT "Next tcap will ask for the number of voltage sources. It will then"
PRINT "ask for the number of components. This number includes the voltage"
PRINT "sources. You are then ready to enter the circuit elements. They may"
PRINT "be entered in any order. enter node and element values separated by"
PRINT "commas as directed by tcap. For example a resistor (component type #1)"
PRINT "between nodes 2 and 3 of 120 ohms would be entered as '2,3,120'."
INPUT "Press <cr> to continue", q$: PRINT
PRINT "Sample files: sample-1 and sample-2 are normally included with tcap"
PRINT "to illustrate how files are created. Load and list these files with"
PRINT "with the 'l' function before attempting to enter a circuit of your own.": PRINT
PRINT "Tcap initially assumes calculations are to be at DC (0Hz). For calculations"
PRINT "at other frequencies, the frequency must be set with the 'f' command."
PRINT "Tcap can perform node voltage calculations at a single frequency or over"
PRINT "a range of frequencies (sweep). When performing a non-sweep calculation,"
PRINT "it will always return to the last single frequency specified. tcap can"
PRINT "also calculate over a 'sweep' of component values with the 'c' function."
PRINT "after a component sweep calculation, tcap will return to the original"
PRINT "component value. tcap always tabulates the results of a sweep calculation,"
PRINT "but it can also display these results in graphical form."
PRINT : PRINT "Do you want additional information on functions (y/n)? ";
q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ <> "y" THEN GOTO MoreInfo ELSE PRINT
PRINT "Tcap calculates node voltages with the 'v' function. The 'i' function"
PRINT "calculates the current supplied by all network voltage and current sources,"
PRINT "but does not calculate the current through individual network elements."
PRINT "To determine the voltage across and the current through an element"
PRINT "(or network branch), the 'b' command is used. This function will provide"
PRINT "the voltages across all 2-terminal network elements and the currents"
PRINT "through these elements (except for sources - provided by the 'i' command)."
PRINT "Voltage is defined as positive at the first node relative to the second"
PRINT "node. The 'z' function provides the impedance between a specified node and"
PRINT "ground (node 0) with all voltage sources shorted and all current sources"
PRINT "open circuited. To calculate the input (or output) impedance of a"
PRINT "network, drive the network with a 1 amp current source. The voltage"
PRINT "at the node of the current source equals the desired impedance. this"
PRINT "impedance may be plotted using the 'f' command and sweep function.": PRINT
PRINT "Up to ten components (excluding voltage sources) may be added to"
PRINT "a network with the 'a' function just as long as no additional nodes"
PRINT "are added. 'r' and 'd' allow the substitution and deletion of components.": PRINT
PRINT "the 'm' function causes tcap to display the magnitudes of voltages in dB."
PRINT "A reference voltage must be supplied for the 20 log(V/Vref) calc."
PRINT "The m function is turned off by entering a Vref=0."

MoreInfo: PRINT "Do you want information on active devices (y/n)? ";
q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ <> "y" THEN GOTO NoMoreInfo
CLS : PRINT "Tcap has 5 active device models: pnp, npn and fet transistors, a"
PRINT "controlled voltage source (which can be made to act like a tube) and"
PRINT "an operational amplifier."
PRINT "- PNP and NPN: for ac problems both models are"
PRINT "indentical and consist of a .001ohm resistance (short) connected"
PRINT "between the base and emitter terminals and a controlled current"
PRINT "source between the collector and emitter terminals. The current"
PRINT "produced by this current source is the product of the current "
PRINT "flowing into the base terminal times beta. More complex transistor"
PRINT "models may be created by adding extra elements in series and parallel"
PRINT "with the device terminals. For example a resistor can be put in series"
PRINT "with the base terminal to simulate the effect of rie, or in parallel"
PRINT "with the collector/emitter terminals to simulate the effect of hoe."
PRINT "Active devices can also be combined to make even more complex models."
PRINT : PRINT "In the DC case (f=0), a .7V source is added in series with the"
PRINT "base terminals of the bipolar transistor models, with the appropriate"
PRINT "polarity for either pnp or npn devices, and tcap checks for correct"
PRINT "bias polarity. In the ac case (f>0), the .7V battery is eliminated"
PRINT "and all circuit voltage sources are set to the frequency specified by"
PRINT "'f', i.e., separate circuits are needed for bias (DC) and AC conditions."
PRINT : INPUT "press <cr> to continue", q$: PRINT
PRINT "- Operational Amplifier: controlled voltage source whose"
PRINT "output voltage is the product of the voltage between its (+) and"
PRINT "(-) terminals times gain. An open circuit (2 megohms) is present "
PRINT "between the (+) and (-) terminals which are floating relative to the"
PRINT "output. The output voltage source has effectively a zero impedance and"
PRINT "is connected to ground (node 0)."
PRINT "- FET: controlled current source, its output depends on the voltage at"
PRINT "the gate terminal times mu. It has both infinite input and output impedances."
PRINT "Both input and output terminals are referenced to the source node."
PRINT "DC wise, the FET model can be considered an enhancement type fet, "
PRINT "but no check is made for correct (linear) bias conditions."
PRINT "- CVS (controlled voltage source):"
PRINT "similar to the op-amp, but has both input and output voltage"
PRINT "referenced to its common cathode node. It has infinite input"
PRINT "and zero output Zs. To make the CVS model a vacuum tube, a"
PRINT "large resistor should be added in series with the plate node."
PRINT : PRINT "Want hard copy of above information (y/n)? ";
q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ = "y" THEN GOSUB HardCopyText

NoMoreInfo:
CLEAR : pi = 4 * ATN(1): p2 = pi * 2: p6 = pi / 180
PRINT : PRINT "Do you want to enter a file (y/n)? ";
a$ = LCASE$(INPUT$(1)): PRINT a$: IF a$ = "y" THEN GOTO FileLoad
1200 PRINT : INPUT "What is the highest node number"; ls
     IF ls < 1 OR ls <> INT(ls) THEN 1200
1220 INPUT "How many voltage sources are in the circuit"; lv
     IF lv < 0 OR lv <> INT(lv) THEN 1220 ELSE no = ls + lv
1250 INPUT "How many components (incl. sources) are in the circuit"; ct
     IF ct < 1 OR ct <> INT(ct) THEN 1250
     DIM y(no, no + 1), x(no, no + 1), t(ct + lv + 5), n1(ct + lv + 5), n2(ct + lv + 5), v(ct + lv + 5), g(ct + lv + 5)
     DIM fp(1001), fr(1001), fy(1001), ff(1001)
     FOR cr = 1 TO ct: GOSUB 2190: NEXT: GOTO Options

TcapError:
PRINT : PRINT "A tcap program error has occured": ON ERROR GOTO TcapError

Menu: ' *********************************************************************
w = wb: PRINT "Frequency="; w / p2
PRINT "Select: Add Branch Chng Del End Freq Help I List Magn New Repl Save Volt Z ";
c$ = LCASE$(INPUT$(1)): PRINT c$
IF c$ = "e" THEN PRINT : PRINT "End TSC CAP": CLOSE : END
c$ = LEFT$(c$, 2)
IF c$ = "a" THEN GOSUB 2180
IF c$ = "b" THEN GOSUB BranchVICalc
IF c$ = "n" THEN GOTO NoMoreInfo
IF c$ = "s" THEN GOSUB FileSave
IF c$ = "f" THEN GOSUB FreqSweepModule
IF c$ = "i" THEN GOSUB CurrentCalc
IF c$ = "l" THEN GOSUB ListCircuit
IF c$ = "v" THEN GOSUB 2550
IF c$ = "d" THEN GOSUB RemoveElement
IF c$ = "z" THEN GOSUB ZCalc
IF c$ = "r" THEN GOSUB ComponentInputAddReplace
IF c$ = "c" THEN GOSUB ChangeComponentValues
IF c$ = "m" THEN GOSUB MagInDbSet
IF LEFT$(c$, 1) <> "h" THEN GOTO Menu

Options: ' ******************************************************************
PRINT "Options: a - add circuit compontent             m - voltage magnitude in dB"
PRINT "         b - calculate branch Vs and I          n - new circuit"
PRINT "         c - change and sweep component value   r - replace circuit component"
PRINT "         d - delete circuit component           s - save circuit file"
PRINT "         f - set or sweep frequency             v - calculate node voltages"
PRINT "         i - calculate source currents          z - calculate node impedance"
PRINT "         l - list present components            end - end session": GOTO Menu

FileLoad: '******************************************************************
CLEAR : pi = 4 * ATN(1): p2 = pi * 2: p6 = pi / 180
INPUT "File name (omit extension), 'files', or quit"; file$
IF file$ = "files" THEN FILES "*.cap": PRINT : GOTO FileLoad ELSE IF file$ = "quit" THEN GOTO Menu
file$ = file$ + ".cap": OPEN "i", #1, file$
INPUT #1, ct, ls, lv: no = ls + lv
DIM y(no, no + 1), x(no, no + 1), t(ct + lv + 5), n1(ct + lv + 5)
DIM n2(ct + lv + 5), v(ct + lv + 5), g(ct + lv + 5)
'DIM fp(20), fr(20), fy(20), ff(20)
FOR p = 1 TO ct: INPUT #1, t(p), n1(p), n2(p), v(p), g(p): NEXT
CLOSE #1: GOTO Menu

FileSave: ' *****************************************************************
PRINT : INPUT "file name"; file$: file$ = file$ + ".cap"
OPEN "o", #1, file$
PRINT #1, ct, ls, lv
FOR p = 1 TO ct: PRINT #1, t(p), n1(p), n2(p), v(p), g(p): NEXT
CLOSE #1: RETURN

FreqSweepModule: '***********************************************************
PRINT "Modes:  1 - single frequency"
PRINT "        2 - linear frequency sweep"
PRINT "        3 - log frequency sweep"
PRINT "Frequency mode?"; : lx = VAL(INPUT$(1)): PRINT lx
IF lx < 1 OR lx > 3 THEN GOTO FreqSweepModule
IF lx > 1 THEN GOTO sweep
PRINT : INPUT "Desired frequency"; w
PRINT " Frequency set to "; w; " for all <b>, <i>, <v>, <z> and <c> calculations": w = p2 * w: wb = w: RETURN

sweep:
PRINT : w$ = "Frequency": e$ = "freq"
DO
  PRINT "Maximum number of sweep sections is set to 1000 (1001 points)."
  INPUT "min freq, max freq, # of sections"; f1, f2, in
  IF f1 >= 0 AND f2 >= 0 AND f2 >= f1 THEN EXIT DO
  PRINT "Improper entry"
LOOP

1900 PRINT "Which node? ( 1 -"; ls; ")  "; : INPUT nd
     IF nd > ls OR nd < 1 THEN PRINT "nodes are from 1 to"; ls; "only.": GOTO 1900
     IF lx = 2 THEN f3 = f1: f4 = f2: GOTO 1940
     f4 = LOG(f2) / LOG(10): IF f1 = 0 THEN f3 = 0 ELSE f3 = LOG(f1) / LOG(10)
1940 PRINT : PRINT "Working"; : i = 0: m = in + 1: ii = (f4 - f3) / in: ep = .01 * ii
     FOR p = 0 TO in + 1: fp(p) = 0: fr(p) = 0: fy(p) = 0: ff(p) = 0: NEXT p
     FOR fx = f3 TO f4 + ep STEP ii: i = i + 1: PRINT i;
     IF lx = 3 THEN IF fx <> 0 THEN w = p2 * 10 ^ fx ELSE w = 0
     IF lx = 2 THEN w = p2 * fx
     IF lx = 3 AND fx <> 0 THEN ff(i) = 10 ^ fx ELSE ff(i) = fx
     GOSUB Mat: GOSUB 2740
     fy(i) = y(nd, 0): fr(i) = x(nd, 0): NEXT fx: w = 0: PRINT CHR$(26)
2020 PRINT : PRINT "Voltage - "; w$; " tabulation"; TAB(50); file$
     arch = 9: arch$ = "tcap.xls": OPEN arch$ FOR OUTPUT AS arch
     PRINT TAB(3); e$; TAB(14); "real"; TAB(24); "imaginary"; TAB(36); "magnitude"; r$; TAB(48); "phase angle": cn = 0
     FOR i = 1 TO m: mg = SQR(fy(i) ^ 2 + fr(i) ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10)
     IF cn <> 0 AND cn / 20 = INT(cn / 20) THEN INPUT "press <cr> to continue", a$
     cn = cn + 1: IF fy(i) = 0 THEN k = SGN(fr(i)) * 90 ELSE IF fy(i) > 0 THEN k = 1 / p6 * ATN(fr(i) / fy(i)) ELSE k = 1 / p6 * ATN(fr(i) / fy(i)) + 180
     PRINT USING "###.##^^^^  "; ff(i);
     PRINT USING "##.##^^^^   "; fy(i); fr(i); mg; : PRINT USING "   ####.#"; k
     PRINT #arch, ff(i); CHR$(9); 20 * LOG(mg) / LOG(10)
     NEXT i: PRINT : CLOSE #arch
     PRINT "Want hard copy (y/n)? ";
     q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ = "y" THEN GOSUB HardCopySweepFunc
     PRINT : PRINT "Want to plot voltage (y/n)? ";
     q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ <> "y" THEN 2110
     v$ = "v": IF rf > 0 THEN na$ = "Voltage ratio in dB": GOTO 2130 ELSE na$ = "voltage": GOTO 2130
2110 PRINT : PRINT "Want to plot phase angle (y/n)? ";
     q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ = "y" THEN na$ = "angle ": v$ = "p": GOTO 2130
     RETURN

2130 PRINT : INPUT "Line width (default 80)"; ll: IF ll = 0 THEN ll = 80
     xx = ll: GOTO PlotRoutine

ComponentInputAddReplace: ' *************************************************
PRINT : INPUT "component number"; l
IF l <= ct AND l > 0 THEN zn = l: GOTO 2210 ELSE PRINT "invalid component number. entry ignored.": RETURN

2180 zn = ct: ct = ct + 1
2190 zn = zn + 1: IF cr > 1 THEN 2210
     PRINT : PRINT "component selection section"
2210
PRINT "1 = R   4 = I source   6 = NPN    9 = cont. V source (tube)"
PRINT "2 = L   5 = V source   7 = PNP   10 = operational amplifier"
PRINT "3 = C                  8 = FET "
PRINT : INPUT "Type of circuit element"; ty
     IF ty < 1 OR ty > 10 THEN 2210 ELSE GOTO CompoNumber
2330 INPUT n1(zn), n2(zn), v(zn)
     IF v(zn) < 0 THEN INPUT "Element value must be greater than 0, proper value"; v(zn)
     IF n1(zn) <= ls AND n2(zn) <= ls AND n1(zn) >= 0 AND n2(zn) >= 0 THEN RETURN

ImproperNode:
PRINT "Improper node value. Entry ignored"
t(zn) = 0: zn = zn - 1: RETURN

CompoNumber:
PRINT "component #"; zn
t(zn) = ty: ON ty GOTO 2400, 2410, 2420, 2430, 2460, 2470, 2470, 2490, 2500, 2480

2400 PRINT "node a", "node b", "resistance"; : GOTO 2330

2410 PRINT "node a", "node b", "inductance"; : GOTO 2330

2420 PRINT "node a", "node b", "capacitance"; : GOTO 2330

2430 PRINT "- node", "+node", "current mag.", "phase angle";
2440 INPUT n1(zn), n2(zn), v(zn), g(zn)
     IF n1(zn) <= ls AND n2(zn) <= ls AND n1(zn) >= 0 AND n2(zn) >= 0 THEN RETURN ELSE GOTO ImproperNode
2460 PRINT "- node", "+ node", "voltage mag.", "phase angle"; : GOTO 2440

2470 PRINT "base node", "emitter node", "collector node", "beta"; : GOTO 2440

2480 PRINT "output", "- input", "+ input", "gain factor"; : GOTO 2440

2490 PRINT "gate node", "source node", "drain node", "gm"; : GOTO 2440

2500 PRINT "grid node", "cathode node", "plate node", "voltage gain"; : GOTO 2440

NodeVoltageCalc: ' **********************************************************
PRINT : PRINT " node? (0 -"; ls; ")  "; : INPUT nd
     IF nd > ls THEN PRINT "the highest node number is "; ls: GOTO NodeVoltageCalc
     IF nd >= 0 THEN 2560
2550 PRINT : PRINT "Enter number from 0-"; ls; "an entry of 0 will provide solution at all nodes"
     GOTO NodeVoltageCalc

2560 PRINT : PRINT "Working": GOSUB Mat: GOSUB 2740
2570 PRINT : IF c$ = "i" THEN PRINT file$, "current" ELSE IF c$ = "z" THEN PRINT file$, "impedance" ELSE PRINT file$, "voltage"
     PRINT "frequency="; w / p2: PRINT
     IF c$ = "z" THEN rk = rf: rf = 0: GOSUB 3260
     PRINT "node"; TAB(11); "real"; TAB(21); "imaginary"; TAB(33); "magnitude"; r$; TAB(44); "phase angle"
     IF c$ = "i" THEN RETURN
     IF nd = 0 THEN 2630
2620 l = nd: GOTO 2640

2630 FOR l = 1 TO ls
2640 mg = SQR(y(l, 0) ^ 2 + x(l, 0) ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10)
     IF y(l, 0) = 0 THEN pa = 90 * SGN(x(l, 0)) ELSE IF y(l, 0) > 0 THEN pa = 1 / p6 * ATN(x(l, 0) / y(l, 0)) ELSE pa = 1 / p6 * ATN(x(l, 0) / y(l, 0)) + 180
     IF c$ = "i" THEN PRINT n1(lq); "-"; n2(lq); : GOTO 2680
     PRINT l; TAB(9);
2680 PRINT USING "##.##^^^^   "; y(l, 0); x(l, 0); mg; : PRINT USING " ####.#"; pa
     IF l / 20 = INT(l / 20) THEN PRINT : INPUT "Press <cr> to continue"; fr: PRINT
     IF nd <> 0 THEN 2710
     NEXT l
2710 IF c$ = "i" THEN RETURN
     PRINT : INPUT "want hard copy (y/n)"; q$: IF q$ = "y" THEN GOSUB HardCopyNvZI
     IF c$ = "z" THEN rf = rk: GOSUB 3260
     RETURN

2740 FOR l = 1 TO no: IF y(l, l) ^ 2 + x(l, l) ^ 2 <> 0 THEN 2770
     FOR lt = 1 TO no: IF y(l, lt) ^ 2 + x(l, lt) ^ 2 <> 0 OR y(lt, l) ^ 2 + x(lt, l) ^ 2 <> 0 THEN 2770
     NEXT lt: IF y(l, no + 1) ^ 2 + x(l, no + 1) ^ 2 <> 0 THEN 2770 ELSE y(l, l) = 1
2770 NEXT l: FOR l = 1 TO no
2780 de = y(l, l) ^ 2 + x(l, l) ^ 2: IF de > 1E-14 OR (l = no AND de <> 0) THEN 2860
     IF l = no THEN GOTO OneProblemExists
     FOR lt = l + 1 TO no: IF (y(l, l) + y(lt, l)) ^ 2 + (x(l, l) + x(lt, l)) ^ 2 < 1E-14 THEN 2820
     FOR lr = 1 TO no + 1: y(l, lr) = y(l, lr) + y(lt, lr): x(l, lr) = x(l, lr) + x(lt, lr): NEXT lr: GOTO 2780

2820 NEXT lt
OneProblemExists:
PRINT "One of the following problems exist:"
PRINT "(1) improper connection at "; : IF l > ls THEN PRINT "voltage source" ELSE PRINT "node"; l
PRINT "(2) circuit will not operate at a frequency of"; w / p2; " recheck circuit connections using the 'l' command.": PRINT : RETURN

2860 dr = y(l, l) / de: di = -x(l, l) / de
     FOR j = 1 TO no
     IF j = l THEN 2960
     IF nd = 0 THEN 2910
     IF j >= l THEN 2910 ELSE IF j <> nd THEN 2960
2910 IF y(j, l) = 0 AND x(j, l) = 0 THEN 2960
     fr = y(j, l) * dr - x(j, l) * di: fi = x(j, l) * dr + y(j, l) * di
     FOR p = l + 1 TO no + 1
     tr = y(l, p) * fr - x(l, p) * fi: ti = x(l, p) * fr + y(l, p) * fi
     y(j, p) = y(j, p) - tr: x(j, p) = x(j, p) - ti: NEXT p
2960 NEXT j: NEXT l
     FOR l = 1 TO no: df = y(l, l) ^ 2 + x(l, l) ^ 2: y(l, 0) = (y(l, no + 1) * y(l, l) + x(l, no + 1) * x(l, l)) / df
     x(l, 0) = (x(l, no + 1) * y(l, l) - y(l, no + 1) * x(l, l)) / df: NEXT l
     IF w <> 0 THEN RETURN
     FOR rl = 1 TO ct: IF t(rl) > 5 AND t(rl) < 11 THEN 3020
3010 NEXT rl: RETURN

3020 y(0, 0) = 0: x(0, 0) = 0
     dp = SGN(y(n1(rl), 0)) * SQR(y(n1(rl), 0) ^ 2 + x(n1(rl), 0) ^ 2)
     dm = SGN(y(n2(rl), 0)) * SQR(y(n2(rl), 0) ^ 2 + x(n2(rl), 0) ^ 2)
     sp = SGN(y(v(rl), 0)) * SQR(y(v(rl), 0) ^ 2 + x(v(rl), 0) ^ 2)
     dp = INT(1000 * dp) / 1000: dm = INT(1000 * dm) / 1000: sp = INT(1000 * sp) / 1000
     ON t(rl) - 5 GOTO 3090, 3130
     GOTO 3010

3090 IF dp >= dm + .7 THEN 3110
3100 PRINT "Base-emitter junction of transistor at b="; n1(rl); "e="; n2(rl); "c="; v(rl): GOTO 3150

3110 IF sp >= dp THEN 3010
3120 PRINT "Base-collector junction of transistor at b="; n1(rl); "e="; n2(rl); "c="; v(rl): GOTO 3150

3130 IF dm - .7 < dp THEN 3100
     IF sp > dp THEN 3120 ELSE 3010

3150 PRINT "is reverse biased.  linear circuit analysis is not possible.": RETURN

RemoveElement: ' ************************************************************
PRINT : INPUT "Component number"; l
     IF l <= ct AND l > 0 THEN 3190 ELSE PRINT "invalid component number. entry ignored.": RETURN
3190 IF l = ct THEN 3200 ELSE FOR p = l TO ct - 1: t(p) = t(p + 1): n1(p) = n1(p + 1): n2(p) = n2(p + 1): v(p) = v(p + 1): g(p) = g(p + 1): NEXT: ct = ct - 1: RETURN
3200 t(ct) = 0: ct = ct - 1: RETURN

MagInDbSet: ' ***************************************************************
     PRINT : PRINT "All voltage magnitudes will be in dB relative to reference."
     PRINT "To reset to normal mode enter zero or carriage return."
3240 INPUT "Reference voltage for dB calc"; rf
     IF rf < 0 THEN PRINT : PRINT "dB ref must be > 0!": GOTO 3240
3260 r$ = " dB": IF rf = 0 THEN r$ = "": RETURN ELSE RETURN

ZCalc: ' ********************************************************************
PRINT : PRINT "Impedance at which node?  ( 1 -"; ls; ")  "; : INPUT nd: IF nd < 1 OR nd > ls THEN GOTO ZCalc
     PRINT : PRINT "working": PRINT : FOR l = 1 TO no: FOR cr = 1 TO no + 1: y(l, cr) = 0: x(l, cr) = 0: NEXT cr: NEXT l
     cr = ct: FOR ct = 1 TO cr
     IF t(ct) = 5 THEN y = 10000000000#: GOSUB 3650
     IF t(ct) <> 5 THEN GOSUB 3590
     NEXT ct: ct = cr: FOR l = 1 TO no: IF l = nd THEN y(l, no + 1) = 1 ELSE y(l, no + 1) = 0
     x(l, no + 1) = 0: NEXT l: GOSUB 2740: GOTO 2570

ChangeComponentValues: ' ****************************************************
     PRINT : PRINT "Variable component mode"
     w$ = "Component value": e$ = "value"
     PRINT "Frequency should be pre-set with <f> mode <1>"
     PRINT : INPUT "Component # to be varied"; zn
     IF zn > ct OR zn < 1 THEN PRINT "Point out of range": RETURN
3410 INPUT "Min value, max value and # of points"; c1, c2, in
     IF c1 >= 0 AND c2 >= 0 AND c2 > c1 THEN 3440
     PRINT "Improper entry": GOTO 3410
3440 PRINT "Which node? ( 1 -"; ls; ")  "; : INPUT nd
     IF nd > ls OR nd < 1 THEN PRINT "Nodes are from 1 to"; ls; "only.": GOTO 3440
     PRINT : PRINT "Working"; : i = 0: m = in + 1: ep = .01 * (c2 - c1) / in
     FOR p = 0 TO in + 1: fp(p) = 0: fr(p) = 0: fy(p) = 0: ff(p) = 0: NEXT p
     IF t(zn) < 6 THEN tv = v(zn) ELSE tv = g(zn)
     FOR cx = c1 TO c2 + ep STEP (c2 - c1) / in: i = i + 1: PRINT i;
     IF t(zn) < 6 THEN v(zn) = cx ELSE g(zn) = cx
     ff(i) = cx: GOSUB Mat: GOSUB 2740
     fy(i) = y(nd, 0): fr(i) = x(nd, 0): NEXT cx
     IF t(zn) < 6 THEN v(zn) = tv ELSE g(zn) = tv
     GOTO 2020

     REM <back to freq sweep tab module> ****

Mat: ' **********************************************************************
FOR l = 1 TO no: FOR p = 1 TO no + 1: y(l, p) = 0: x(l, p) = 0: NEXT p: NEXT l
lp = 1: cr = ct: FOR ct = 1 TO cr: GOSUB 3590
NEXT ct: ct = cr: RETURN

3590 ON t(ct) GOTO 3600, 3620, 3640, 3760, 3810, 3840, 3850, 4030, 4040, 4000
3600 IF v(ct) = 0 THEN y = 10000000000# ELSE y = 1 / v(ct)
     x = 0: GOTO 3650
3620 IF w <> 0 THEN x = -1 / (w * v(ct)) ELSE x = 10000000000#
     y = 0: GOTO 3650
3640 y = 0: x = w * v(ct)
3650 IF x ^ 2 + y ^ 2 < 1E-34 AND x ^ 2 + y ^ 2 <> 0 THEN PRINT "admittance underflow. component number"; ct: GOTO Menu
     IF y = 0 THEN 3710
3670 y(n1(ct), n1(ct)) = y(n1(ct), n1(ct)) + y
     y(n1(ct), n2(ct)) = y(n1(ct), n2(ct)) - y
     y(n2(ct), n1(ct)) = y(n2(ct), n1(ct)) - y
     y(n2(ct), n2(ct)) = y(n2(ct), n2(ct)) + y
3710 IF x = 0 THEN RETURN
     x(n1(ct), n1(ct)) = x(n1(ct), n1(ct)) + x
     x(n1(ct), n2(ct)) = x(n1(ct), n2(ct)) - x
     x(n2(ct), n1(ct)) = x(n2(ct), n1(ct)) - x
     x(n2(ct), n2(ct)) = x(n2(ct), n2(ct)) + x: RETURN

3760 y = v(ct) * COS(p6 * g(ct)): x = v(ct) * SIN(p6 * g(ct))
     y(n1(ct), no + 1) = y(n1(ct), no + 1) - y
     x(n1(ct), no + 1) = x(n1(ct), no + 1) - x
     y(n2(ct), no + 1) = y(n2(ct), no + 1) + y
     x(n2(ct), no + 1) = x(n2(ct), no + 1) + x: RETURN

3810 y(n1(ct), ls + lp) = y(n1(ct), ls + lp) + 1: y(n2(ct), ls + lp) = y(n2(ct), ls + lp) - 1
     y(ls + lp, n1(ct)) = y(ls + lp, n1(ct)) - 1: y(ls + lp, n2(ct)) = y(ls + lp, n2(ct)) + 1
     y(ls + lp, no + 1) = y(ls + lp, no + 1) + v(ct) * COS(p6 * g(ct)): x(ls + lp, no + 1) = x(ls + lp, no + 1) + v(ct) * SIN(p6 * g(ct)): lp = lp + 1: RETURN

3840 dp = n1(ct): sp = v(ct): dm = n2(ct): sm = n2(ct): GOTO 3860
3850 dp = n2(ct): sp = n2(ct): dm = n1(ct): sm = v(ct)
3860 y(sp, dp) = y(sp, dp) + g(ct) * 1000
     y(sp, dm) = y(sp, dm) - g(ct) * 1000
     y(sm, dm) = y(sm, dm) + g(ct) * 1000
     y(sm, dp) = y(sm, dp) - g(ct) * 1000
     IF w <> 0 THEN 3950
     y(sp, no + 1) = y(sp, no + 1) + 700 * g(ct)
     y(sm, no + 1) = y(sm, no + 1) - 700 * g(ct)
     y(dp, no + 1) = y(dp, no + 1) + 700
     y(dm, no + 1) = y(dm, no + 1) - 700
3950 y = 1000: x = 0: GOTO 3670
3960 y(sp, dm) = y(sp, dm) - g(ct)
     y(sp, dp) = y(sp, dp) + g(ct)
     y(sm, dp) = y(sm, dp) - g(ct)
     y(sm, dm) = y(sm, dm) + g(ct): RETURN

4000 y = 10000000000#: x = 0: nn = n2(ct): n2(ct) = 0: GOSUB 3670: n2(ct) = nn: nn = n1(ct): n1(ct) = v(ct): y = .0000005: GOSUB 3670: n1(ct) = nn
     g(ct) = g(ct) * 10000000000#: dp = n2(ct): sp = n1(ct): dm = v(ct): sm = 0: GOSUB 3960
     g(ct) = g(ct) * 1E-10: RETURN

4030 dp = n1(ct): sp = v(ct): dm = n2(ct): sm = n2(ct): GOTO 3960
4040 dp = n1(ct): sp = v(ct): dm = n2(ct): sm = n2(ct): g(ct) = g(ct) * 10000000000#: GOSUB 3960
     g(ct) = g(ct) * 1E-10: y = 10000000000#: x = 0: nn = n1(ct): n1(ct) = v(ct): GOSUB 3670: n1(ct) = nn: RETURN

ListCircuit: ' **************************************************************
PRINT : PRINT file$, "frequency="; w / p2: PRINT
PRINT "comp#"; TAB(7); "to nodes"; TAB(27); "type"; TAB(39); "value"; TAB(53); "phase angle"
FOR l = 1 TO ct: PRINT l; TAB(7);
ON t(l) GOTO 4150, 4160, 4170, 4180, 4190, 4200, 4210, 4230, 4240, 4220

4120 IF l / 20 = INT(l / 20) THEN INPUT "press <cr> to continue"; zz
     NEXT l
     PRINT "want hard copy (y/n)? ";
     q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ = "y" THEN GOSUB HardCopyComponentList
     RETURN

4150 PRINT n1(l); "-"; n2(l); TAB(27); "resistor"; TAB(39); v(l): GOTO 4120

4160 PRINT n1(l); "-"; n2(l); TAB(27); "inductor"; TAB(39); v(l): GOTO 4120

4170 PRINT n1(l); "-"; n2(l); TAB(27); "capacitor"; TAB(39); v(l): GOTO 4120

4180 PRINT n1(l); "-"; n2(l); TAB(27); "current"; TAB(39); v(l); TAB(53); g(l): GOTO 4120

4190 PRINT n1(l); "-"; n2(l); TAB(27); "voltage"; TAB(39); v(l); TAB(53); g(l)
     GOTO 4120

4200 PRINT "b="; n1(l); "e="; n2(l); "c="; v(l); TAB(27); "npn trans."; TAB(39); " beta="; g(l): GOTO 4120

4210 PRINT "b="; n1(l); "e="; n2(l); "c="; v(l); TAB(27); "pnp trans."; TAB(39); " beta="; g(l): GOTO 4120

4220 PRINT "o="; n1(l); "-="; n2(l); "+="; v(l); TAB(27); "op amp"; TAB(39); " gain="; g(l): GOTO 4120

4230 PRINT "g="; n1(l); "s="; n2(l); "d="; v(l); TAB(27); "fet trans."; TAB(39); " gm="; g(l): GOTO 4120

4240 PRINT "g="; n1(l); "c="; n2(l); "p="; v(l); TAB(27); "cvs (tube)"; TAB(39); " v. gain="; g(l): GOTO 4120

CurrentCalc: ' **************************************************************
PRINT : PRINT "Working": PRINT : nd = 0: GOSUB Mat: GOSUB 2740: GOSUB 2570
nd = ls:
FOR lq = 1 TO ct: IF t(lq) = 5 THEN nd = nd + 1: GOSUB 2620
NEXT lq
PRINT : INPUT "Want hard copy (y/n)"; q$: IF q$ = "y" THEN GOSUB HardCopyNvZI ELSE RETURN
nd = ls:
FOR lq = 1 TO ct: IF t(lq) = 5 THEN nd = nd + 1: GOSUB 6080
NEXT lq: RETURN

BranchVICalc: ' *************************************************************
PRINT : PRINT "enter a component number from 0-"; ct; " only two node elements will be calculated.": nd = 0: d = 0
PRINT "entry of '0' will provide a solution for all valid branchs."
DO
  PRINT : PRINT " Component? (0-"; ct; ")  "; : INPUT lb: cc = 1: PRINT
  IF lb > ct THEN PRINT "The highest element number is "; ct ELSE EXIT DO
LOOP
     IF lb < 0 THEN GOTO BranchVICalc
     PRINT "Working": GOSUB Mat: GOSUB 2740
4412 IF d = 0 THEN PRINT : PRINT "Comp #"; TAB(11); "real"; TAB(21); "imaginary"; TAB(33); "magnitude"; r$; TAB(45); "phase angle"
     IF d = 2 THEN LPRINT : LPRINT "Comp #"; TAB(11); "real"; TAB(21); "imaginary"; TAB(33); "magnitude"; r$; TAB(45); "phase angle"
     IF d = 0 THEN PRINT : PRINT "Branch voltage(s):"
     IF d = 2 THEN LPRINT : LPRINT "Branch voltage(s):"
     IF lb > 0 THEN lt = lb: GOTO 4440
     FOR lt = 1 TO ct: cc = cc + 1
4440 IF t(lt) > 5 THEN 4510 ELSE yb = y(n1(lt), 0) - y(n2(lt), 0): xb = x(n1(lt), 0) - x(n2(lt), 0)
     IF n2(lt) = 0 THEN yb = y(n1(lt), 0): xb = x(n1(lt), 0)
     IF n1(lt) = 0 THEN yb = -y(n2(lt), 0): xb = -x(n2(lt), 0)
     mg = SQR(yb ^ 2 + xb ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10)
     IF yb = 0 THEN pa = 90 * SGN(xb) ELSE IF yb > 0 THEN pa = 1 / p6 * ATN(xb / yb) ELSE pa = 1 / p6 * ATN(xb / yb) + 180
     IF d = 0 THEN PRINT lt; TAB(9); : PRINT USING "##.##^^^^   "; yb; xb; mg; : PRINT USING "####.#"; pa
     IF d = 2 THEN LPRINT lt; TAB(9); : LPRINT USING "##.##^^^^   "; yb; xb; mg; : LPRINT USING "####.#"; pa
     IF d = 0 AND cc / 20 = INT(cc / 20) THEN PRINT : INPUT "press <cr> to continue"; fr: PRINT
4510 IF lb <> 0 THEN 4520
     NEXT lt
4520 IF d = 0 THEN PRINT "branch current(s): (excluding sources - use 'i' command for sources)"
     IF d = 2 THEN LPRINT "branch current(s):"
     IF lb > 0 THEN 4550
     FOR lt = 1 TO ct: cc = cc + 1
4550 IF t(lt) > 3 THEN 4650 ELSE yb = y(n1(lt), 0) - y(n2(lt), 0): xb = x(n1(lt), 0) - x(n2(lt), 0)
     IF n2(lt) = 0 THEN yb = y(n1(lt), 0): xb = x(n1(lt), 0)
     IF n1(lt) = 0 THEN yb = -y(n2(lt), 0): xb = -x(n2(lt), 0)
     IF t(lt) = 1 THEN yb = yb / v(lt): xb = xb / v(lt)
     IF t(lt) = 2 THEN tb = yb: IF w = 0 THEN yb = xb * 10000000000#: xb = -tb * 10000000000# ELSE yb = xb / (w * v(lt)): xb = -tb / (w * v(lt))
     IF t(lt) = 3 THEN tb = yb: yb = -xb * w * v(lt): xb = tb * w * v(lt)
     mg = SQR(yb ^ 2 + xb ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10)
     IF yb = 0 THEN pa = 90 * SGN(xb) ELSE IF yb > 0 THEN pa = 1 / p6 * ATN(xb / yb) ELSE pa = 1 / p6 * ATN(xb / yb) + 180
     IF d = 0 THEN PRINT lt; TAB(9); : PRINT USING "##.##^^^^   "; yb; xb; mg; : PRINT USING "####.#"; pa
     IF d = 2 THEN LPRINT lt; TAB(9); : LPRINT USING "##.##^^^^   "; yb; xb; mg; : LPRINT USING "####.#"; pa
     IF d = 0 AND cc / 20 = INT(cc / 20) THEN PRINT : INPUT "press <cr> to continue"; fr: PRINT
4650 IF lb <> 0 THEN 4654
     NEXT lt
4654 IF d = 0 THEN PRINT : INPUT "Want hard copy (y/n)"; q$: IF q$ = "y" THEN d = 2: GOTO 4412
     d = 0: RETURN

PlotRoutine: ' **************************************************************
PRINT : IF lx = 3 THEN PRINT "Log frequency plot";  ELSE PRINT w$; " plot";
     PRINT TAB(35); file$: PRINT : lf = ll - 18: sn = 0: sh = 0: FOR i = 1 TO m
     IF v$ = "v" THEN mg = SQR(fy(i) ^ 2 + fr(i) ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10): GOTO 4720 ELSE 4720
     IF fy(i) = 0 THEN k = SGN(fr(i)) * 90 ELSE IF fy(i) > 0 THEN k = 1 / p6 * ATN(fr(i) / fy(i)) ELSE k = 1 / p6 * ATN(fr(i) / fy(i)) + 180
4720 IF v$ = "v" THEN fp(i) = mg ELSE fp(i) = k
     IF fp(i) > sh THEN sh = fp(i)
     IF fp(i) < sn THEN sn = fp(i)
     NEXT i
IF sn > 0 THEN sn = 0 ELSE sn = -sn
IF sh < 0 THEN sh = 0
sf = sh + sn: zv = INT(lf * sn / sf + 11)
PRINT f1$; TAB(lf / 2 + 7); na$
i1 = INT(lf / 2): i2 = INT(lf * sh / (2 * sf)): i3 = INT(lf * sn / (2 * sf)): iq = INT(lf / 4): ih = INT(3 * lf / 4)
IF sh = 0 THEN PRINT TAB(10); -sn; TAB(iq + 10); -3 * sn / 4; TAB(i1 + 10); -sn / 2; TAB(ih + 10); -sn / 4; TAB(lf + 10); sh: GOTO EjeX
IF sn = 0 THEN PRINT TAB(10); sn; TAB(iq + 10); sh / 4; TAB(i1 + 10); sh / 2; TAB(ih + 10); 3 * sh / 4; TAB(lf + 10); sh: GOTO EjeX
IF zv < (lf / 4 + 11) THEN PRINT TAB(10); -sn; TAB(zv); "0"; TAB(zv + i2 - 1); sh / 2; TAB(lf + 10); sh: GOTO EjeX
IF zv > (3 * lf / 4 + 11) THEN PRINT TAB(10); -sn; TAB(i3 + 10); -sn / 2; TAB(zv); "0"; TAB(lf + 10); sh: GOTO EjeX
PRINT TAB(10); -sn; TAB(i3 + 10); -sn / 2; TAB(zv); "0"; TAB(zv + i2 - 1); sh / 2; TAB(lf + 10); sh
EjeX:
PRINT STRING$(11, 45); "+";
IF sn = 0 OR sh = 0 THEN PRINT STRING$(iq - 1, 45); "+"; STRING$(i1 - iq - 1, 45); "+"; STRING$(ih - i1 - 1, 45); "+"; STRING$(lf - ih - 1, 45); "+": GOTO 4900
IF zv < (lf / 4 + 11) THEN PRINT STRING$(zv - 11, 45); "+"; STRING$(i2 - 1, 45); "+"; STRING$(lf - zv - i2 + 10, 45); "+": GOTO 4900
IF zv > (3 * lf / 4 + 11) THEN PRINT STRING$(i3 - 1, 45); "+"; STRING$(zv - i3 - 12, 45); "+"; STRING$(lf - zv + 10, 45); "+": GOTO 4900
PRINT STRING$(i3 - 1, 45); "+"; STRING$(zv - i3 - 12, 45); "+"; STRING$(i2 - 1, 45); "+"; STRING$(lf - zv - i2 + 10, 45); "+"

4900 cn = 0: FOR i = 1 TO m: vn = INT(lf * (sn + fp(i)) / sf + 11): PRINT USING "####^^^^"; ff(i);
     IF vn > 11 THEN PRINT TAB(11); "|";
     IF vn = zv THEN PRINT TAB(zv); "*": GOTO 4950
     IF vn > zv AND zv > 11 THEN PRINT TAB(zv); "."; TAB(vn); "*": GOTO 4950
     IF vn > zv THEN PRINT TAB(vn); "*" ELSE PRINT TAB(vn); "*"; TAB(zv); "."
4950 IF cn <> 0 AND cn / 20 = INT(cn / 20) THEN INPUT "press <cr> to continue"; a$
     cn = cn + 1
     NEXT i: PRINT : PRINT "Want hard copy (y/n)? ";
     q$ = LCASE$(INPUT$(1)): PRINT q$: IF q$ = "y" THEN ll = 74: GOSUB HardCopyPlot
     IF v$ = "v" THEN PRINT : PRINT "Want to plot phase angle (y/n)? "; : p$ = LCASE$(INPUT$(1)): PRINT p$: IF p$ = "y" THEN na$ = "angle ": v$ = "p": ll = xx: GOTO PlotRoutine
     IF v$ = "p" AND p$ <> "y" THEN PRINT : PRINT "Want to plot voltage (y/n)? "; : q$ = LCASE$(INPUT$(1)): PRINT q$:  ELSE RETURN
     IF q$ <> "y" THEN RETURN ELSE v$ = "v": ll = xx: IF rf > 0 THEN na$ = "voltage ratio in dB": GOTO PlotRoutine ELSE na$ = "voltage": GOTO PlotRoutine

HardCopyText: ' *************************************************************
LPRINT : LPRINT "tcap is a program for the analysis of electrical circuits consisting"
LPRINT "of resistors, capacitors, inductors and several common active devices."
LPRINT "first draw the circuit to be analayzed on a sheet of paper. assign a"
LPRINT "number to each element of the circuit. this is the component number."
LPRINT "next assign a number to each network node. a node is present at the"
LPRINT "connection between elements. no two elements may be connected without"
LPRINT "a node between them. every element must begin and end at a node. any"
LPRINT "number of elements may be connected to a common node.": LPRINT :
LPRINT "once all the elements and nodes are numbered, you are ready to enter"
LPRINT "your network into tcap.": LPRINT
LPRINT "tcap will first ask whether you wish to read a file. tcap allows you"
LPRINT "to save on disk circuit files ('s') you have previously worked on. if"
LPRINT "you do not have a previous file you wish to work on, type 'n' or"
LPRINT "hit carriage return and tcap will put you in the new file mode. in"
LPRINT "the new file mode, tcap will first ask for the highest node number."
LPRINT "next tcap will ask for the number of voltage sources. it will then"
LPRINT "ask for the number of components. this number includes the voltage"
LPRINT "sources. you are then ready to enter the circuit elements. they may"
LPRINT "be entered in any order. enter node and element values separated by"
LPRINT "commas as directed by tcap. for example a resistor (component type #1)"
LPRINT "between nodes 2 and 3 of 120 ohms would be entered as '2,3,120'.": LPRINT
LPRINT "tcap initially assumes calculations are to be at dc (0 hz). for calculations"
LPRINT "at other frequencies, the frequency must be set with the 'f' command."
LPRINT "tcap can perform node voltage calculations at a single frequency or over"
LPRINT "a range of frequencies (sweep). when performing a non-sweep calculation,"
LPRINT "it will always return to the last single frequency specified. tcap can"
LPRINT "also calculate over a 'sweep' of component values with the 'c' function."
LPRINT "after a component sweep calculation, tcap will return to the original"
LPRINT "component value. tcap always tabulates the results of a sweep calculation,"
LPRINT "but it can also display these results in graphical form."
LPRINT : LPRINT "tcap calculates node voltages with the 'v' function. the 'i' function"
LPRINT "calculates the current supplied by all network voltage and current sources,"
LPRINT "but does not calculate the current through individual network elements."
LPRINT "to determine the voltage across and the current through an element"
LPRINT "(or network branch), the 'b' command is used. this function will provide"
LPRINT "the voltages across all 2-terminal network elements and the currents"
LPRINT "through these elements (except for sources - provided by the 'i' command)."
LPRINT "voltage is defined as positive at the first node relative to the second"
LPRINT "node. the 'z' function provides the impedance between a specified node and"
LPRINT "ground (node 0) with all voltage sources shorted and all current sources"
LPRINT "open circuited. to calculate the input (or output) impedance of a"
LPRINT "network, drive the network with a 1 amp current source. the voltage"
LPRINT "at the node of the current source equals the desired impedance. this"
LPRINT "impedance may be plotted using the 'f' command and sweep function.": LPRINT
LPRINT "any number of components (excluding voltage sources) may be added to"
LPRINT "a network with the 'a' function just as long as no additional nodes"
LPRINT "are added. 'r' and 'd' allow the substitution and deletion of components.": LPRINT
LPRINT "the 'm' function causes tcap to display the magnitudes of voltages in"
LPRINT "dB. a reference voltage must be supplied for the 20 log(v/vref) calc."
LPRINT "the m function is turned off by entering a vref=0."
LPRINT CHR$(12): LPRINT "tcap has 5 active device models: pnp, npn and fet transistors, a"
LPRINT "controlled voltage source (which can be made to act like a tube) and"
LPRINT "an operational amplifier. for ac problems the pnp and npn models are"
LPRINT "indentical and consist of a .001 ohm resistance (short) connected"
LPRINT "between the base and emitter terminals and a controlled current"
LPRINT "source between the collector and emitter terminals. the current"
LPRINT "produced by this current source is the product of the current "
LPRINT "flowing into the base terminal times beta. more complex transistor"
LPRINT "models may be created by adding extra elements in series and parallel"
LPRINT "with the device terminals. for example a resistor can be put in series"
LPRINT "with the base terminal to simulate the effect of rie, or in parallel"
LPRINT "with the collector/emitter terminals to simulate the effect of hoe."
LPRINT "active devices can also be combined to make even more complex models."
LPRINT : LPRINT "in the dc case (f=0), a .7 volt source is added in series with the"
LPRINT "base terminals of the bipolar transistor models, with the appropriate"
LPRINT "polarity for either pnp or npn devices, and tcap checks for correct"
LPRINT "bias polarity. in the ac case (f>0), the .7 volt battery is eliminated"
LPRINT "and all circuit voltage sources are set to the frequency specified by"
LPRINT "'f', i.e., separate circuits are needed for bias (dc) and ac conditions."
LPRINT : LPRINT "the operational amplifier is a controlled voltage source whose"
LPRINT "output voltage is the product of the voltage between its (+) and"
LPRINT "(-) terminals times gain. an open circuit (2 megohms) is present be-"
LPRINT "tween the (+) and (-) terminals which are floating relative to the"
LPRINT "output. the output voltage source has effectively a zero impedance and"
LPRINT "is connected to ground (node 0). the fet model is a controlled current"
LPRINT "source, whose output depends on the voltage at the gate terminal times mu."
LPRINT "it has both infinite input and output impedances. both input and output"
LPRINT "terminals are referenced to the source node. dc wise, the fet model"
LPRINT "can be considered an enhancement type fet, but no check is made for "
LPRINT "correct (linear) bias conditions. the cvs (controlled voltage source)"
LPRINT "is similar to the op-amp, but has both input and output voltage"
LPRINT "referenced to its common cathode node. it has infinite input"
LPRINT "and zero output impedances. to make the cvs model a vacuum tube, a"
LPRINT "large resistor should be added in series with the plate node."
LPRINT : LPRINT "options:"
LPRINT TAB(10); , "a - add circuit component"
LPRINT TAB(10); , "b - calculate branch voltages and currents"
LPRINT TAB(10); , "c - change and sweep component value"
LPRINT TAB(10); , "d - delete circuit component"
LPRINT TAB(10); , "f - set or sweep frequency"
LPRINT TAB(10); , "i - calculate source currents"
LPRINT TAB(10); , "l - list present components"
LPRINT TAB(10); , "m - voltage magnitude in dB"
LPRINT TAB(10); , "n - new circuit"
LPRINT TAB(10); , "r - replace circuit component":
LPRINT TAB(10); , "s - save circuit file"
LPRINT TAB(10); , "v - calculate node voltages"
LPRINT TAB(10); , "z - calculate node impedance"
LPRINT TAB(10); , "end - end session": RETURN

HardCopyNvZI: ' ************************************************************
LPRINT : IF c$ = "i" THEN LPRINT file$, "current" ELSE IF c$ = "z" THEN LPRINT file$, "impedance" ELSE LPRINT file$, "voltage"
     LPRINT "frequency="; w / p2: LPRINT
     LPRINT "node"; TAB(11); "real"; TAB(21); "imaginary"; TAB(33); "magnitude"; r$; TAB(44); "phase angle"
     IF c$ = "i" THEN RETURN
     IF nd = 0 THEN 6090
6080 l = nd: GOTO 6100
6090 FOR l = 1 TO ls
6100 mg = SQR(y(l, 0) ^ 2 + x(l, 0) ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10)
     IF y(l, 0) = 0 THEN pa = 90 * SGN(x(l, 0)) ELSE IF y(l, 0) > 0 THEN pa = 1 / p6 * ATN(x(l, 0) / y(l, 0)) ELSE pa = 1 / p6 * ATN(x(l, 0) / y(l, 0)) + 180
     IF c$ = "i" THEN LPRINT n1(lq); "-"; n2(lq); : GOTO 6140
     LPRINT l; TAB(9);
6140 LPRINT USING "##.##^^^^   "; y(l, 0); x(l, 0); mg; : LPRINT USING " ####.#"; pa
     IF nd <> 0 THEN RETURN
     NEXT l: RETURN

HardCopyComponentList: ' ****************************************************
LPRINT : LPRINT file$, "frequency="; w / p2: LPRINT
LPRINT "comp."; TAB(7); "node": LPRINT "no."; TAB(7); "connection"; TAB(27); "type"; TAB(39); "value"; TAB(53); "phase angle"
FOR l = 1 TO ct: LPRINT l; TAB(7);
ON t(l) GOTO 6240, 6250, 6260, 6270, 6280, 6290, 6300, 6310, 6320, 6330
6220 NEXT l: RETURN

6240 LPRINT n1(l); "-"; n2(l); TAB(27); "resistor"; TAB(39); v(l): GOTO 6220

6250 LPRINT n1(l); "-"; n2(l); TAB(27); "inductor"; TAB(39); v(l): GOTO 6220

6260 LPRINT n1(l); "-"; n2(l); TAB(27); "capacitor"; TAB(39); v(l): GOTO 6220

6270 LPRINT n1(l); "-"; n2(l); TAB(27); "current"; TAB(39); v(l); TAB(53); g(l): GOTO 6220

6280 LPRINT n1(l); "-"; n2(l); TAB(27); "voltage"; TAB(39); v(l); TAB(53); g(l): GOTO 6220

6290 LPRINT "b="; n1(l); "e="; n2(l); "c="; v(l); TAB(27); "npn trans."; TAB(39); " beta="; g(l): GOTO 6220

6300 LPRINT "b="; n1(l); "e="; n2(l); "c="; v(l); TAB(27); "pnp trans."; TAB(39); " beta="; g(l): GOTO 6220

6310 LPRINT "o="; n1(l); "-="; n2(l); "+="; v(l); TAB(27); "op amp"; TAB(39); " gain="; g(l): GOTO 6220

6320 LPRINT "g="; n1(l); "s="; n2(l); "d="; v(l); TAB(27); "fet trans."; TAB(39); " gm="; g(l): GOTO 6220

6330 LPRINT "g="; n1(l); "c="; n2(l); "p="; v(l); TAB(27); "cvs (tube)"; TAB(39); " v. gain="; g(l): GOTO 6220

HardCopyPlot: ' *************************************************************
LPRINT : IF lx = 3 THEN LPRINT "log frequency plot";  ELSE LPRINT w$; " plot";
     LPRINT TAB(35); file$: LPRINT : lf = ll - 18: sn = 0: sh = 0: FOR i = 1 TO m
     IF v$ = "v" THEN mg = SQR(fy(i) ^ 2 + fr(i) ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10): GOTO 6380 ELSE 6380
     IF fy(i) = 0 THEN k = SGN(fr(i)) * 90 ELSE IF fy(i) > 0 THEN k = 1 / p6 * ATN(fr(i) / fy(i)) ELSE k = 1 / p6 * ATN(fr(i) / fy(i)) + 180
6380 IF v$ = "v" THEN fp(i) = mg ELSE fp(i) = k
     IF fp(i) > sh THEN sh = fp(i)
     IF fp(i) < sn THEN sn = fp(i)
     NEXT i
     IF sn > 0 THEN sn = 0 ELSE sn = -sn
     IF sh < 0 THEN sh = 0
     sf = sh + sn: zv = INT(lf * sn / sf + 11)
     LPRINT f1$; TAB(lf / 2 + 7); na$
     i1 = INT(lf / 2): i2 = INT(lf * sh / (2 * sf)): i3 = INT(lf * sn / (2 * sf)): iq = INT(lf / 4): ih = INT(3 * lf / 4)
     IF sh = 0 THEN LPRINT TAB(10); -sn; TAB(iq + 10); -3 * sn / 4; TAB(i1 + 10); -sn / 2; TAB(ih + 10); -sn / 4; TAB(lf + 10); sh: GOTO 6510
     IF sn = 0 THEN LPRINT TAB(10); sn; TAB(iq + 10); sh / 4; TAB(i1 + 10); sh / 2; TAB(ih + 10); 3 * sh / 4; TAB(lf + 10); sh: GOTO 6510
     IF zv < (lf / 4 + 11) THEN LPRINT TAB(10); -sn; TAB(zv); "0"; TAB(zv + i2 - 1); sh / 2; TAB(lf + 10); sh: GOTO 6510
     IF zv > (3 * lf / 4 + 11) THEN LPRINT TAB(10); -sn; TAB(i3 + 10); -sn / 2; TAB(zv); "0"; TAB(lf + 10); sh: GOTO 6510
     LPRINT TAB(10); -sn; TAB(i3 + 10); -sn / 2; TAB(zv); "0"; TAB(zv + i2 - 1); sh / 2; TAB(lf + 10); sh
6510 LPRINT STRING$(11, 45); "+";
     IF sn = 0 OR sh = 0 THEN LPRINT STRING$(iq - 1, 45); "+"; STRING$(i1 - iq - 1, 45); "+"; STRING$(ih - i1 - 1, 45); "+"; STRING$(lf - ih - 1, 45); "+": GOTO 6560
     IF zv < (lf / 4 + 11) THEN LPRINT STRING$(zv - 11, 45); "+"; STRING$(i2 - 1, 45); "+"; STRING$(lf - zv - i2 + 10, 45); "+": GOTO 6560
     IF zv > (3 * lf / 4 + 11) THEN LPRINT STRING$(i3 - 1, 45); "+"; STRING$(zv - i3 - 12, 45); "+"; STRING$(lf - zv + 10, 45); "+": GOTO 6560
     LPRINT STRING$(i3 - 1, 45); "+"; STRING$(zv - i3 - 12, 45); "+"; STRING$(i2 - 1, 45); "+"; STRING$(lf - zv - i2 + 10, 45); "+"
6560 cn = 0: FOR i = 1 TO m: vn = INT(lf * (sn + fp(i)) / sf + 11): LPRINT USING "####^^^^"; ff(i);
     IF vn > 11 THEN LPRINT TAB(11); "|";
     IF vn = zv THEN LPRINT TAB(zv); "*": GOTO 6610
     IF vn > zv AND zv > 11 THEN LPRINT TAB(zv); "."; TAB(vn); "*": GOTO 6610
     IF vn > zv THEN LPRINT TAB(vn); "*" ELSE LPRINT TAB(vn); "*"; TAB(zv); "."
6610 NEXT i: RETURN

HardCopySweepFunc: ' ********************************************************
LPRINT : LPRINT "Voltage - "; w$; " tabulation"; TAB(50); file$: LPRINT
LPRINT TAB(3); e$; TAB(14); "real"; TAB(24); "imaginary"; TAB(36); "magnitude"; r$; TAB(48); "phase angle"
FOR i = 1 TO m: mg = SQR(fy(i) ^ 2 + fr(i) ^ 2): IF rf > 0 THEN mg = 20 * LOG(mg / rf + 1E-10) / LOG(10)
IF fy(i) = 0 THEN k = SGN(fr(i)) * 90 ELSE IF fy(i) > 0 THEN k = 1 / p6 * ATN(fr(i) / fy(i)) ELSE k = 1 / p6 * ATN(fr(i) / fy(i)) + 180
LPRINT USING "###.#^^^^  "; ff(i);
LPRINT USING "##.##^^^^   "; fy(i); fr(i); mg; : LPRINT USING "   ####.#"; k
NEXT i
RETURN

